package org.rcisoft.business.bchapter.entity;


import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.NotEmpty;
import org.hibernate.validator.constraints.Range;
import org.rcisoft.business.bchapter.dao.BChapterRepository;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
* Created with gwf on 2017-7-21 15:08:46.
*/
@Entity
@Table(name = "b_chapter")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BChapter extends IdEntity<BChapter> {

    /*开课id*/
    @NotEmpty(message = "开课id必填")
    private String slId;
    /*章节名称*/
    @NotEmpty(message = "章节名称必填")
    @Length(min = 1,max = 50,message = "长度最小为1,最大为50")
    private String chapterName;
    /*等级*/
    @Range(max = 2,min = 1,message = "等级最小为1,最大为2")
    private Byte chapterLevel;
    /*父ID*/
    private String pid;
    /*课程url*/
    private String chapterUrl;

    /**任务书*/
    private String mdFile;
    /*1:实验  2:视频   3:PPT*/
    private String isTest;
    @Transient
    private List<BChapterRepository> childList;

    @Transient
    private String studentNum;

    @Transient
    private String videoUrl;


    @Transient
    private String fileUrl;




}

