package org.rcisoft.business.blesson.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.blesson.entity.BLesson;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * Created with CodeGenerator on .
 */
@Repository
public interface BLessonRepository extends BaseMapper<BLesson> {

    /**
     * 根据条件查找
     *
     * @param param
     * @return
     */
    @Select("<script>select * from b_lesson b "+
            "where b.del_flag != 1" +
            "<if test=\"name!=null\">and b.`lesson_name` like #{name}</if>"+
            "<if test=\"code!=null\">and b.`code` like #{code}</if></script>")
    @ResultMap(value = "BaseResultMap")
    List<BLesson> queryBLessons(Map<String, Object> param);

    @Select("<script>select * from b_lesson where code = #{code}</script>")
    @ResultMap(value = "BaseResultMap")
    BLesson queryBLessonByCode(String code);

    @Insert("<script>INSERT INTO b_lesson" +
            "(create_date,update_date,del_flag,flag,business_id,code,lesson_name,default_url,create_by)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code},#{item.lessonName},#{item.defaultUrl},#{item.createBy})" +
            "</foreach></script>")
    int insertList(List<BLesson> bLessons);

}

