package org.rcisoft.business.bsl.entity;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.Length;
import org.rcisoft.core.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
* Created with CodeGenerator on 2017/07/12.
*/
@Entity
@Table(name = "b_sl")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class BSl extends IdEntity<BSl> {

    public BSl(String code, String lessonCode, String teacherCode, String termCode) {
        this.code = code;
        this.lessonCode = lessonCode;
        this.teacherCode = teacherCode;
        this.termCode = termCode;
    }

    public BSl(String code) {
        this.code = code;
    }

    private String code;//课序号
    private String lessonCode;//课程编号
    private String teacherCode;//教师编号
    private String termCode;//学期编号
    private String isOnline;//是否上线，（0：待上线，1：已上线，2：已下线）
    private String slCoverUrl;  //课程封面
    @Length(min = 1,max = 200,message = "长度最小为1,最大为200")
    private String slNotes;  //课程简介
    private String isRecommend;  //是否推荐
    private Date recommendDate;  //推荐日期
    private Integer recommendOrder;  //推荐序号

    @Length(min = 1,max = 200,message = "长度最小为1,最大为200")
    private String recommendCourse;  //推荐原因

    private String gitLabProjectId;   //gitlab项目id

    private String gitLabProjectName;  //gitlab项目名

     @Transient
    private String teacherName;// 教师姓名

    @Transient
    private String lessonName;//课程名称

    @Transient
    private String termName;//学期名称

    @Transient
    private String studyNum;//在学人数

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;

        BSl bSl = (BSl) o;

        if (code != null ? !code.equals(bSl.code) : bSl.code != null) return false;
        if (lessonCode != null ? !lessonCode.equals(bSl.lessonCode) : bSl.lessonCode != null) return false;
        if (teacherCode != null ? !teacherCode.equals(bSl.teacherCode) : bSl.teacherCode != null) return false;
        return termCode != null ? termCode.equals(bSl.termCode) : bSl.termCode == null;
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 31 * result + (code != null ? code.hashCode() : 0);
        result = 31 * result + (lessonCode != null ? lessonCode.hashCode() : 0);
        result = 31 * result + (teacherCode != null ? teacherCode.hashCode() : 0);
        result = 31 * result + (termCode != null ? termCode.hashCode() : 0);
        return result;
    }
}

