package org.rcisoft.business.bstudent.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bstudent.entity.BStudent;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with CodeGenerator on .
*/
@Repository
public interface BStudentRepository extends BaseMapper<BStudent> {

    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>SELECT\n" +
            "\tb.`business_id`,\n" +
            "\tb.`code`,\n" +
            "\tb.`is_recommend`,\n" +
            "\tb.`recommend_order`,\n" +
            "\tb.`recommend_course`,\n" +
            "\tb.`recommend_date`,\n" +
            "\tb.create_by,\n" +
            "\tb.create_date,\n" +
            "\tb.del_flag,\n" +
            "\tb.flag,\n" +
            "\tb.remarks,\n" +
            "\tb.update_by,\n" +
            "\tb.update_date,\n" +
            "\tu.`name`,\n" +
            "\tu.email,\n" +
            "\tu.phone,\n" +
            "\tu.sex,\n" +
            "\tu.head_pic\n" +
            "FROM\n" +
            "\tb_student b\n" +
            "LEFT JOIN s_user u ON b.`code` = u.login_name\n" +
            " where b.del_flag != 1"+
            "<if test=\"name!=null\">and u.`name` like #{name}</if>"+
            "<if test=\"code!=null\">and b.`code` like #{code}</if></script>")
    @ResultMap(value = "BaseResultMap" )
    List<BStudent> queryBStudents(Map<String, Object> param);

    @Select("<script>SELECT\n" +
            "\tt3.`code`,t4.`name`\n" +
            "FROM\n" +
            "b_r_class_student t2\n" +
            "LEFT JOIN b_student t3 ON t2.student_code = t3.`code`\n" +
            "LEFT JOIN s_user t4 ON t3.`code` = t4.login_name\n" +
            "WHERE\n" +
            "\tt2.class_code = #{classCode}</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BStudent> queryStudentByClassCode(@Param("classCode") String classCode);

    @Select("<script>SELECT\n" +
            "\tt3.`code`,t4.`name`\n" +
            "FROM\n" +
            "b_r_sl_student t2\n" +
            "LEFT JOIN b_student t3 ON t2.student_code = t3.`code`\n" +
            "LEFT JOIN s_user t4 ON t3.`code` = t4.login_name\n" +
            "WHERE\n" +
            "\tt2.sl_code = #{slCode}</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BStudent> queryStudentBySlCode(@Param("slCode") String slCode);

    @Insert("<script>INSERT INTO b_student" +
            "(create_date,update_date,create_by,update_by,remarks,del_flag,flag,business_id,code)VALUES" +
            "<foreach collection=\"list\" item=\"item\" separator=\",\">" +
            "( #{item.createDate},#{item.updateDate},#{item.createBy},#{item.updateBy},#{item.remarks},#{item.delFlag},#{item.flag},#{item.businessId},#{item.code})" +
            "</foreach></script>")
    int insertList(List<BStudent> bStudents);

    /**
     * 查询推荐学生
     * @return
     */
    @Select("<script>SELECT\n" +
            "\tb.`business_id`,\n" +
            "\tb.`code`,\n" +
            "\tb.`is_recommend`,\n" +
            "\tb.`recommend_date`,\n" +
            "\tb.`recommend_order`,\n" +
            "\tb.`recommend_course`,\n" +
            "\tb.create_by,\n" +
            "\tb.create_date,\n" +
            "\tb.del_flag,\n" +
            "\tb.flag,\n" +
            "\tb.remarks,\n" +
            "\tb.update_by,\n" +
            "\tb.update_date,\n" +
            "\tu.`name`,\n" +
            "\tu.email,\n" +
            "\tu.phone,\n" +
            "\tu.sex,\n" +
            "\tu.head_pic\n" +
            "FROM\n" +
            "\tb_student b\n" +
            "LEFT JOIN s_user u ON b.`code` = u.login_name\n" +
            "where b.del_flag = '0' " +
            "and b.flag = '1' "+
            "and b.is_recommend = '1' "+
            "</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BStudent> queryStudentWithReCommend();

    @Select("<script>select b.business_id from b_student b left join s_user s on b.code = s.login_name where s.business_id = #{userId}</script>")
    String queryStudentByUserId(String userId);


}

