package org.rcisoft.business.bstudent.service.impl;

import com.alibaba.fastjson.JSON;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.rcisoft.business.brslstudent.dao.BRSlStudentRepository;
import org.rcisoft.business.bstudent.dao.BStudentRepository;
import org.rcisoft.business.bstudent.entity.BStudent;
import org.rcisoft.business.bstudent.service.BStudentService;
import org.rcisoft.common.component.Global;
import org.rcisoft.common.component.PageUtil;
import org.rcisoft.core.entity.DataEntity;
import org.rcisoft.core.exception.ServiceException;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.ResultServiceEnums;
import org.rcisoft.core.util.ExcelUtil;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.sys.user.entity.SysUser;
import org.rcisoft.sys.user.entity.UserRole;
import org.rcisoft.sys.user.service.UserService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * Created by CodeGenerator on 2017/07/12.
 */
@Service
@Transactional(readOnly = true, propagation = Propagation.NOT_SUPPORTED)
public class BStudentServiceImpl implements BStudentService {
    @Autowired
    private BStudentRepository bStudentRepository;
    @Autowired
    private UserService userService;
    /*@Autowired
    private UserRepository userRepository;
    @Autowired
    private IAction action;*/
    @Autowired
    private Global global;
    @Autowired
    private BRSlStudentRepository brSlStudentRepository;

    @Override
    public BStudent selectOne(String businessId) {
        return bStudentRepository.selectByPrimaryKey(businessId);
    }

    @Override
    public List<BStudent> queryBStudentsByPagination(PageUtil pageUtil, BStudent model) {
        return bStudentRepository.queryBStudents(queryParamHandler(model));
    }

    @Override
    public List<BStudent> queryBStudents(BStudent model) {
        return bStudentRepository.queryBStudents(queryParamHandler(model));
    }


    @Override
    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    public PersistModel persist(BStudent model, SysUser user, String token) throws UnsupportedEncodingException {
        int line = 0;
        BeanUtils.copyProperties((DataEntity) model, (DataEntity) user);
        if (model.getBusinessId() == null) {  //添加
            /*if (userRepository.selectOne(new User(model.getCode())) != null)
                throw new ServiceException(ResultServiceEnums.STUDENT_EXISTS);
            User user1 = new User();
            user1.setEmail(model.getEmail());
            if(userRepository.selectOne(user1)!=null)
                throw new ServiceException(ResultServiceEnums.EMAIL_EXISTS);

            //1. 添加用户
            user.setCommonBusinessId();
            //1.1 创建git lab账户
            GitUser gitUser = new GitUser();
            gitUser.setUsername(global.getGIT_LAB_STU_PREFIX()+model.getCode());
            gitUser.setName(user.getName());
            gitUser.setPassword(model.getCode());
            gitUser.setEmail(user.getEmail());
            AccountDTO accountDTO = action.createGitLabAccount(gitUser);
            //1.2 将git lab账户信息保存进user里
            user.setGitLabId(accountDTO.getId());
            user.setGitLabUsername(accountDTO.getUsername());
            user.setGitLabImpressionToken(accountDTO.getImpersonationToken());
            user.setHeadPic(global.getDEFAULT_STUDENT_LOCATION());
            userService.persistUser(user);*/

            //2.添加学生
            UserUtil.setCurrentPersistOperation(model,token);
            line = bStudentRepository.insertSelective(model);

            //3.添加权限
            UserRole userRole = new UserRole(user.getBusinessId(), "cccccccc");
            userRole.setCommonBusinessId();

            /*int line1 = userRepository.insertUserRole(userRole);
            if (line1 != line)
                throw new ServiceException(ResultServiceEnums.INSERT_ERROR);*/
        } else {  //修改
            /*String uid = userRepository.selectUserIdByStuOrTeaId(model.getBusinessId(), "b_student");
            if (uid == null)
                throw new ServiceException(ResultServiceEnums.STUDENT_NOT_EXISTS);
            UserUtil.setCurrentMergeOperation(model,token);*/
            line = bStudentRepository.updateByPrimaryKeySelective(model);
            /*userService.updateUser(user,uid,line);*/
        }
        return new PersistModel(line);
    }

    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    @Override
    public PersistModel importExcel(HSSFWorkbook hwb,String token) throws IOException {
        ArrayList<BStudent> students = new ArrayList<BStudent>();

        ArrayList<SysUser> users = new ArrayList<SysUser>();
        ArrayList<UserRole> userRoles = new ArrayList<UserRole>();
        String[] headers = {"学号", "学生姓名", "性别","邮箱"};
        ArrayList<String[]> values = ExcelUtil.importExcel(hwb, headers);  //获取excel数据

        if (values.size()<0){
            throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DATA_NOT_EXIST);
        }

        List<String[]> valuesOK = new ArrayList<>();
        List<String> valuesRepeat = new ArrayList<>();
        List<String> valuesShort = new ArrayList<>();
        List<String> valuesEmailExist = new ArrayList<>();

        for (String[] value : values) {

            String stuCode = value[0];

            //判断1:学号是否满足8~15位；
            if(stuCode.length()<8||stuCode.length()>15){
                //该用户不满足要求，记入valuesShort中
                valuesShort.add(value[0]);
                continue;
            }

            //判断2:MySQL数据库中是否存在该用户；
            /*User user1 =new User();
            user1.setLoginName(value[0]);
            if (userRepository.selectOne(user1) != null) {
                //该用户已存在，记入codeRepeat中
                valuesRepeat.add(value[0]);
                continue;
            }*/

            //判断3:邮箱是否存在、格式是否正确；
            /*User user2 = new User();
            user2.setEmail(value[3]);
            boolean nullEmail = StringUtils.isEmpty(value[3]);
            boolean emailCheck = RegexValidateUtil.checkEmail(value[3]);
            boolean emailRepeat = userRepository.selectOne(user2)!=null;
            if(nullEmail||!emailCheck||emailRepeat){
                valuesEmailExist.add(value[3]);
                continue;
            }*/

            //合法:通过了三次判断，证明可建立该用户
            valuesOK.add(value);
            //为合法的用户建立Gitlab账户，并批量存储Student、User和UserRole;
            /*if (value[2].equals("女"))
                value[2] = UserSexEnum.WOMEN.getCode();
            else
                value[2] = UserSexEnum.MAN.getCode();

            //1. 添加user
            User user = new User(value[0], UserConstant.INITIAL_PASSWORD, value[1], value[2]);  //学号，密码，姓名，性别;
            user.setEmail(value[3]);
            user.setCommonBusinessId();
            UserUtil.setCurrentPersistOperation(user,token);
            //2 创建gitlab账户
            GitUser gitUser = new GitUser();
            gitUser.setUsername(global.getGIT_LAB_STU_PREFIX()+value[0]);
            gitUser.setName(value[1]);
            gitUser.setPassword(value[0]);
            gitUser.setEmail(value[3]);
            AccountDTO accountDTO = action.createGitLabAccount(gitUser);
            //3. 将gitlab账户信息保存进user里
            user.setGitLabId(accountDTO.getId());
            user.setGitLabUsername(accountDTO.getUsername());
            user.setGitLabImpressionToken(accountDTO.getImpersonationToken());
            user.setHeadPic(global.getDEFAULT_STUDENT_LOCATION());*/

            //4.添加用户权限
//            UserRole userRole = new UserRole(user.getBusinessId(), "cccccccc");
//            userRole.setCommonBusinessId();

            //创建完Gitlab账户后，将完整的User信息和UserRole计入users和userRoles中等待插入数据库
            /*BStudent bStudent = new BStudent(value[0]);
            UserUtil.setCurrentPersistOperation(bStudent,token);
            if (!students.contains(bStudent)) {
                students.add(bStudent);
                users.add(user);
                userRoles.add(userRole);
            }*/
        }


        String result = "";
        if (valuesOK.size()>0){
            int line1 = bStudentRepository.insertList(students);
            /*int line2 = userRepository.insertList(users);
            int line3 = userRepository.insertUserRoleList(userRoles);
            if (line1 != line2 || line1 != students.size() || line2 != users.size() || line1 != line3 || line3 != userRoles.size()) {
                throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DB_INSERT_ERROR);
            }else{
                result+="成功导入"+users.size()+"名学生。";
            }*/
        }

        if(valuesRepeat.size()>0){
            result+="以下学生的学号存在重复："+ JSON.toJSONString(valuesRepeat)+"。";
        }
        if(valuesShort.size()>0){
            result+="以下学生的学号位数不在8~15位之间："+ JSON.toJSONString(valuesShort)+"。";
        }
        if(valuesEmailExist.size()>0){
            result+="以下邮箱已注册："+ JSON.toJSONString(valuesEmailExist)+"。";
        }


        if (valuesOK.size()<1){
            throw new ServiceException(ResultServiceEnums.EXCEL_IMPORT_DB_INSERT_ERROR.getCode(),result);
        }
        return new PersistModel(1, result);



    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED,readOnly = false)
    public PersistModel removeBBStudent(String id) {
        if(brSlStudentRepository.selectSlNumByStuId(id)>0)
            throw new ServiceException(ResultServiceEnums.STUDENT_HAS_SL);
        /*User user = userRepository.selectUserByStuOrTeaId(id,"b_student");
        userService.removeUser(user);*/
        int line = bStudentRepository.deleteByPrimaryKey(id);
        return new PersistModel(line);
    }

    @Override
    public List<BStudent> queryStudentByClassCodeByPagination(PageUtil pageUtil, String code) {
        List<BStudent> list = bStudentRepository.queryStudentByClassCode(code);
        return list;
    }

    @Override
    public List<BStudent> queryStudentBySlByPagination(PageUtil pageUtil, String code) {
        return bStudentRepository.queryStudentBySlCode(code);
    }

    @Override
    public List<BStudent> queryStudentsWithIsRecommendByPagination(PageUtil pageUtil) {
        return bStudentRepository.queryStudentWithReCommend();
    }

    private Map<String, Object> queryParamHandler(BStudent model) {
        Map param = new HashMap<String, Object>();
        if (model.getName() != null)
            param.put("name", "%" + model.getName() + "%");
        else
            param.put("name", "%%");
        if (model.getCode() != null)
            param.put("code", "%" + model.getCode() + "%");
        else
            param.put("code", "%%");
        return param;
    }
}
