package org.rcisoft.business.bvideo.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.bvideo.entity.BVideo;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with gaowenfneg on 2017-10-9 14:34:56.
*/
@Repository
public interface BVideoRepository extends BaseMapper<BVideo> {

    /**
    * 根据条件查找
    * @param param
    * @return
    */
    @Select("<script>select * from b_video</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BVideo> queryBVideos(Map<String, Object> param);

    @Insert("<script>insert into b_r_chapter_video (video_id,chapter_id,type) values (#{businessId},#{chapterId},#{type})</script>")
    int insertChapterVideo(BVideo model);

    @Select("<script>SELECT\n" +
            "\tbv.* from b_video bv\n" +
            "\tLEFT JOIN b_r_chapter_video bcv on bcv.video_id = bv.business_id\n" +
            "\twhere bcv.chapter_id = #{0} " +
            "and bcv.type = #{1}</script>")
    @ResultMap(value = "BaseResultMap" )
    BVideo selectInfoByChapterId(String chapterId, String type);

    @Select("<script>SELECT\n" +
            "\tbv.*\n" +
            "FROM\n" +
            "\tb_video bv\n" +
            "LEFT JOIN b_r_chapter_video brc ON bv.business_id = brc.video_id\n" +
            "WHERE\n" +
            "\tbrc.chapter_id = #{chapterId}\n" +
            "AND brc.type = '1'</script>")
    @ResultMap(value = "BaseResultMap" )
    BVideo queryFileUrlByChapterId(String chapterId);
}

