package org.rcisoft.business.bvideo.service;

import org.rcisoft.business.bvideo.entity.BVideo;
import org.rcisoft.common.component.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * Created by gaowenfneg on 2017-10-9 14:34:56.
 */
public interface BVideoService{
    /**
    * 根据主键唯一查找
    * @param businessId
    * @return
    */
    BVideo selectOne(String businessId);

    /**
    * 根据条件分页查找
    * @param pageUtil
    * @param model
    * @return
    */
    List<BVideo> queryBVideosByPagination(PageUtil pageUtil, BVideo model);

    /**
    * 根据条件查找全部
    * @param model
    * @return
    */
    List<BVideo> queryBVideos(BVideo model);

    /**
    * 插入
    * @param model
    * @return
    */
    PersistModel persist(BVideo model,String token);

    /**
    * 逻辑删除
    * @param id
    * @return
    */
    PersistModel removeBVideo(String id, String token);

    public String uploadVideoToServer(List<MultipartFile> list, BVideo bVideo, String path,String token);

    public BVideo queryFileUrlByChapterId(String chapterId);
}
