package org.rcisoft.sys.role.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.google.common.collect.Lists;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.rcisoft.core.entity.IdEntity;
import org.rcisoft.sys.menu.entity.Menu;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * Created with family.
 * author: cy
 * Date: 16/6/2
 * Time: 上午9:31
 * description: role
 */
@Entity
@Table(name = "sys_role")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class SysRole extends IdEntity<SysRole> {


    private static final long serialVersionUID = -437438239495993636L;
    /*角色名称*/
    private String name;
    /**
	 * 获取的用户名
	 */
	@Transient
	private String username;

	/*权限code*/
    private String code;

    @Transient
    private String checked;


    @Transient
    private List<Menu> menuList = Lists.newArrayList(); // 拥有菜单列表

    public SysRole(String id, String name) {
        this();
        this.businessId = id;
        this.name = name;
    }


	@Transient
    @JsonIgnore
    public List<Menu> getMenuList() {
        return menuList;
    }

    public void setMenuList(List<Menu> menuList) {
        this.menuList = menuList;
    }


    /**
     * 获取权限字符串列表
     */
    @Transient
    @JsonIgnore
    public List<String> getPermissions() {
        List<String> permissions = Lists.newArrayList();
        for (Menu menu : menuList) {
            if (menu.getPermission()!=null && !"".equals(menu.getPermission())){
                permissions.add(menu.getPermission());
            }
        }
        return permissions;
    }
}
